package com.david.oviedotourist.activities;

import android.os.Bundle;
import android.support.v7.app.ActionBar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.MenuItem;

import com.david.oviedotourist.R;
import com.google.android.gms.maps.OnStreetViewPanoramaReadyCallback;
import com.google.android.gms.maps.StreetViewPanorama;
import com.google.android.gms.maps.StreetViewPanoramaFragment;

/**
 * Created by David on 02/12/2016.
 */

public class StreetViewActivity extends AppCompatActivity
        implements OnStreetViewPanoramaReadyCallback {

    private String panoramicId, siteName;


    //////////////////////////////Activity Lifecycle///////////////////////////////

    @Override
    protected void onCreate(Bundle saveInstanceState) {
        super.onCreate(saveInstanceState);
        setContentView(R.layout.street_view);

        Bundle bundle = getIntent().getExtras();
        siteName = bundle.getString("name", "");

        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        if (getSupportActionBar() != null) {
            ActionBar actionBar = getSupportActionBar();
            actionBar.setDisplayHomeAsUpEnabled(true);
            actionBar.setTitle(siteName);
        }

        panoramicId = bundle.getString("panoId", "");

        StreetViewPanoramaFragment panoramaFragment = (StreetViewPanoramaFragment)
                getFragmentManager().findFragmentById(R.id.street_view);
        panoramaFragment.getStreetViewPanoramaAsync(this);
    }

    //////////////OnStreetViewPanoramaReadyCallback implementation////////////////

    @Override
    public void onStreetViewPanoramaReady(StreetViewPanorama streetViewPanorama) {
        if (!panoramicId.isEmpty()) {
            streetViewPanorama.setStreetNamesEnabled(false);
            streetViewPanorama.setUserNavigationEnabled(false);
            streetViewPanorama.setPosition(panoramicId);
        }
    }

    //////////////////////////////////ActionBar Options//////////////////////////////////

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
        }
        return super.onOptionsItemSelected(item);
    }
}
