package com.david.oviedotourist.data;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import com.david.oviedotourist.R;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by David on 25/11/2016.
 */

public class MySitesDatabase extends SQLiteOpenHelper {


    /////////////////////////SqLiteOpenHelper methods////////////////////////

    public MySitesDatabase(Context context) {
        super(context, "live_tour.db", null, 1);
    }

    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL("CREATE TABLE live_tour (" +
                "_id INTEGER PRIMARY KEY AUTOINCREMENT, " +
                "favourite TEXT, " +
                "visit TEXT)");
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion,
                          int newVersion) {

    }

    /////////////////////////////////////////////////////////////////////////////////

    public boolean searchSite(String siteId, String list) {

        SQLiteDatabase database = getReadableDatabase();
        Cursor cursor = database.rawQuery("SELECT * FROM live_tour WHERE " +
                list + " = '" + siteId + "'", null);

        if (cursor.getCount() <= 0) {
            cursor.close();
            return false;
        }
        cursor.close();
        return true;

    }

    public void saveSite(Context context, String siteId, String list) {
        String favourite = context.getResources().getStringArray(R.array.list_types)[0];
        String visit = context.getResources().getStringArray(R.array.list_types)[1];

        SQLiteDatabase database = getWritableDatabase();

        if (list.equals(favourite) && !searchSite(siteId, "favourite")) {
            database.execSQL("INSERT INTO live_tour VALUES (" +
                    "null, " + "'" + siteId + "', null)");
        }else if (list.equals(visit) && !searchSite(siteId, "visit")) {
            database.execSQL("INSERT INTO live_tour VALUES (" +
                    "null, null, '" + siteId + "')");
        }
        database.close();
    }

    public void deleteSite(Context context, String siteId, String list) {
        String favourite = context.getResources().getStringArray(R.array.list_types)[0];
        String visit = context.getResources().getStringArray(R.array.list_types)[1];

        SQLiteDatabase database = getWritableDatabase();

        if (list.equals(favourite) && searchSite(siteId, "favourite")) {
            database.execSQL("DELETE FROM live_tour WHERE " +
                    "favourite = '" + siteId + "'");
        }else if (list.equals(visit) && searchSite(siteId, "visit")) {
            database.execSQL("DELETE FROM live_tour WHERE " +
                    "visit = '" + siteId + "'");
        }
        database.close();
    }

    public List<String> mySiteList (String fieldName){
        List<String> myList = new ArrayList<>();
        SQLiteDatabase database = getReadableDatabase();

        Cursor cursor = database.rawQuery("SELECT " + fieldName + " FROM " +
                "live_tour", null);

        while (cursor.moveToNext()){
            myList.add(cursor.getString(0));
        }
        cursor.close();
        database.close();

        return myList;
    }
}
