package com.david.oviedotourist.fragments;

import android.app.AlertDialog;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.MultiSelectListPreference;
import android.preference.Preference;
import android.preference.PreferenceFragment;
import android.preference.PreferenceManager;

import com.david.oviedotourist.R;

import java.util.Set;

/**
 * Created by David on 23/11/2016.
 */

public class SettingsFragment extends PreferenceFragment {


    //////////////////////////////Fragment Lifecycle///////////////////////////////

    @Override
    public void onCreate(Bundle saveInstanceState) {
        super.onCreate(saveInstanceState);
        addPreferencesFromResource(R.xml.preferences);

        SharedPreferences preferences = PreferenceManager
                .getDefaultSharedPreferences(getActivity());
        final MultiSelectListPreference typeList = (MultiSelectListPreference)
                findPreference("prf_site_type");
        Set<String> selectedTypes = preferences.getStringSet("prf_site_type", null);
        setSummary(typeList, selectedTypes);

        typeList.setOnPreferenceChangeListener(new Preference.OnPreferenceChangeListener() {
            @Override
            public boolean onPreferenceChange(Preference preference, Object newValue) {
                Set<String> selectedTypes = (Set<String>) newValue;
                setSummary(preference, selectedTypes);
                return true;
            }
        });
    }

    private void setSummary(Preference preference, Set<String> selectedTypes) {
        if (selectedTypes != null && selectedTypes.isEmpty()) {
            new AlertDialog.Builder(getActivity())
                    .setTitle(R.string.prf_warming)
                    .setMessage(R.string.prf_no_type_selected_warming)
                    .setPositiveButton(android.R.string.ok, null)
                    .show();
            preference.setSummary(R.string.prf_no_type_selected);
        } else if (selectedTypes != null) {
            String summary = "";
            for (String type : selectedTypes) {
                switch (type) {
                    case "CULTURE":
                        summary = summary + (getString(R.string.culture)) + " ";
                        break;
                    case "NATURE":
                        summary = summary + (getString(R.string.nature)) + " ";
                        break;
                    case "ENTERTAINMENT":
                        summary = summary + (getString(R.string.entertainment)) + " ";
                        break;
                    case "GASTRONOMY":
                        summary = summary + (getString(R.string.gastronomy)) + " ";
                        break;
                    default:
                        break;
                }
            }
            preference.setSummary(getResources()
                    .getString(R.string.prf_site_type_new_summary_start) + " " + summary);
        }
    }
}
