package com.david.oviedotourist.utilities;

import android.content.Context;
import android.view.Gravity;
import android.widget.Toast;

/**
 * Created by David on 14/11/2016.
 */

public class MyNotifications {

    public static final int SHORT_DURATION = 0;
    public static final int LONG_DURATION = 1;

    /**
     * Create a Toast Notification centered in the screen
     * @param context the context from where the toast is launched
     * @param resId  an int reference to a message string
     * @param duration the duration of the Notification. You can use MyNotifications.SHORT_DURATION
     *                 or MyNotifications.LONG_DURATION;
     */
    public static void createToastNotification (Context context, int resId, final int duration){

        Toast toast = Toast.makeText(context, resId, duration);
        toast.setGravity(Gravity.CENTER_VERTICAL & Gravity.CENTER_HORIZONTAL, 0, 0);
        toast.show();
    }

    public static void createToastNotification (Context context, String message, final int duration){

        Toast toast = Toast.makeText(context, message, duration);
        toast.setGravity(Gravity.CENTER_VERTICAL & Gravity.CENTER_HORIZONTAL, 0, 0);
        toast.show();
    }
}
