package com.david.oviedotourist.utilities;

import android.annotation.TargetApi;
import android.app.Activity;
import android.app.Dialog;
import android.app.Fragment;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Build;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AlertDialog;

/**
 * Created by David on 14/11/2016.
 */

public class MyPermissions {


    public static void requestPermissionsFromActivity(final Activity activity, final String[] permissions,
                                                      int [] messageIds, final int[] requestCodes){

        for (int i = 0; i < permissions.length; i++){
            if (ActivityCompat.shouldShowRequestPermissionRationale(activity, permissions[i])){
                final int j = i;
                new AlertDialog.Builder(activity)
                        .setMessage(messageIds[i])
                        .setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialogInterface, int which) {
                                ActivityCompat.requestPermissions(activity, new String[] {permissions[j]},
                                        requestCodes[j]);
                            }
                        })
                        .show();
            } else {
                ActivityCompat.requestPermissions(activity, new String[] {permissions[i]},
                        requestCodes[i]);
            }
        }
    }

    public static void requestPermissionsFromActivity(final Activity activity, final String[] permissions,
                                                      String [] messages, final int[] requestCodes){

        for (int i = 0; i < permissions.length; i++){
            if (ActivityCompat.shouldShowRequestPermissionRationale(activity, permissions[i])){
                final int j = i;
                new AlertDialog.Builder(activity)
                        .setMessage(messages[i])
                        .setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialogInterface, int which) {
                                ActivityCompat.requestPermissions(activity, new String[] {permissions[j]},
                                        requestCodes[j]);
                            }
                        })
                        .show();
            } else {
                ActivityCompat.requestPermissions(activity, new String[] {permissions[i]},
                        requestCodes[i]);
            }
        }
    }

    @TargetApi(Build.VERSION_CODES.M)
    public static void requestPermissionsFromFragment (final Fragment fragment, final String[] permissions,
                                                       final int [] messageIds, final int[] requestCodes){

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            for (int i = 0; i < permissions.length; i++) {
                if (fragment.shouldShowRequestPermissionRationale(permissions[i])) {
                    final int j = i;
                    new AlertDialog.Builder(fragment.getContext())
                            .setMessage(messageIds[i])
                            .setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialogInterface, int which) {
                                    fragment.requestPermissions(new String[]{permissions[j]},
                                            requestCodes[j]);
                                }
                            })
                            .show();
                } else {
                    fragment.requestPermissions(new String[]{permissions[i]},
                            requestCodes[i]);
                }
            }
        }
    }

    public static void requestServiceActivation(final Activity activity, int title, int message,
                                                   final String actionRequest){

        AlertDialog.Builder builder = new AlertDialog.Builder(activity);
        builder.setTitle(title);
        builder.setMessage(message);
        builder.setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {
                Intent intent = new Intent(actionRequest);
                intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                activity.startActivity(intent);
            }
        });
        builder.setNegativeButton(android.R.string.cancel, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {
                activity.finish();
            }
        });
        builder.show();
    }
}
